'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _dotProp = require('dot-prop');

var _dotProp2 = _interopRequireDefault(_dotProp);

var _omniFetch = require('omni-fetch');

var _omniFetch2 = _interopRequireDefault(_omniFetch);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ISTEXFetch(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }
    var source = this.getParam('source', 'id');
    var target = this.getParam('target');
    var id = this.getParam('id', _dotProp2.default.get(data, source, data));
    var sid = this.getParam('sid', 'ezs-istex');
    var location = {
        protocol: 'https:',
        host: 'api.istex.fr'
    };
    if (id.length === 40) {
        location.pathname = '/document/'.concat(id);
    } else if (id.search(/^ark:/) === 0) {
        location.pathname = String(id).concat('/record.json');
    } else {
        throw new Error('Unexpected id.');
    }
    var parameters = {
        sid: sid
    };
    var urlObj = _extends({}, location, {
        search: _qs2.default.stringify(parameters)
    });
    var urlStr = _url2.default.format(urlObj);
    (0, _omniFetch2.default)(urlStr).then(function (response) {
        return response.json();
    }).then(function (json) {
        if (json._error) {
            throw new Error(json._error);
        }
        return feed.send((0, _utils.newValue)(json, target, data));
    }).catch(function (err) {
        err.url = urlStr;
        err.input = data;
        err.target = target;
        feed.send(err);
    });
}

exports.default = {
    ISTEXFetch: ISTEXFetch
};