'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _stream = require('stream');

var _utils = require('./utils');

function ISTEXParseDotCorpus(data, feed) {
    if (this.isLast()) {
        return feed.close();
    }
    var metadata = this.ezs.metaString(data);
    var statement = this.ezs.fromString(data);
    var input = new _stream.PassThrough({ objectMode: true });
    var output = input.pipe(statement).on('data', function (chunk) {
        feed.write(_extends({}, metadata, chunk));
    }).on('error', function (e) {
        feed.write(e);
    }).on('end', function () {
        feed.end();
    });
    (0, _utils.writeTo)(input, metadata, function () {
        return input.end();
    });
}

exports.default = {
    ISTEXParseDotCorpus: ISTEXParseDotCorpus
};